-- For DB2, run this script as db2 administrator with 
-- db2 -tvf createTables.sql

-- For Derby, run this script with 
-- ij createTables.sql
-- you can find ij in $WAS_INSTALL$/derby/bin/embedded or $WAS_INSTALL$/derby/bin/networkserver

----- UNCOMMENT THE FOLLOWING TO CREATE AND CONNECT TO DB2 DATABASE ---------

-- Change OAUTH2DB to the name you want for the database
-- CREATE DATABASE OAUTH2DB USING CODESET UTF8 TERRITORY US;
-- CONNECT TO OAUTH2DB;

----- END SCRIPTS FOR DB2 ----------------------------------------------------

----- UNCOMMENT THE FOLLOWING TO CREATE AND CONNECT TO DERBY DATABASE -------

-- You can connect to Derby as network server
-- CONNECT 'jdbc:derby://localhost:1527/oauth2db;create=true';

-- or connect to embedded derby, you can change D:\ouaht2db to where you put the database
-- CONNECT 'jdbc:derby:D:\oauth2db;create=true';

----- END OF SCRIPTS FOR DERBY -----------------------------------------------

----- CREATE TABLES -----
CREATE TABLE OAuthDBSchema.OAUTH20CACHE (
	LOOKUPKEY VARCHAR(256) NOT NULL, 
	UNIQUEID VARCHAR(128) NOT NULL, 
	COMPONENTID VARCHAR(256) NOT NULL, 
	TYPE VARCHAR(64) NOT NULL, 
	SUBTYPE VARCHAR(64), 
	CREATEDAT BIGINT, 
	LIFETIME INT, 
	EXPIRES BIGINT, 
	TOKENSTRING VARCHAR(2048) NOT NULL, 
	CLIENTID VARCHAR(64) NOT NULL, 
	USERNAME VARCHAR(64) NOT NULL, 
	SCOPE VARCHAR(512) NOT NULL, 
	REDIRECTURI VARCHAR(2048), 
	STATEID VARCHAR(64) NOT NULL
);

CREATE TABLE OAuthDBSchema.OAUTH20CLIENTCONFIG (
	COMPONENTID VARCHAR(256) NOT NULL, 
	CLIENTID VARCHAR(256) NOT NULL, 
	CLIENTSECRET VARCHAR(256), 
	DISPLAYNAME VARCHAR(256) NOT NULL, 
	REDIRECTURI VARCHAR(2048), 
	ENABLED INT
);

----- ADD CONSTRAINTS -----
ALTER TABLE OAuthDBSchema.OAUTH20CACHE 
	ADD CONSTRAINT PK_LOOKUPKEY PRIMARY KEY (LOOKUPKEY);
	
ALTER TABLE OAuthDBSchema.OAUTH20CLIENTCONFIG 
	ADD CONSTRAINT PK_COMPIDCLIENTID PRIMARY KEY (COMPONENTID,CLIENTID);

----- CREATE INDEXES -----
CREATE INDEX OAUTH20CACHE_EXPIRES ON OAUTHDBSCHEMA.OAUTH20CACHE (EXPIRES ASC);

----- SEED DATA -----
-- INSERT INTO OAuthDBSchema.OAUTH20CLIENTCONFIG (COMPONENTID, CLIENTID, CLIENTSECRET, DISPLAYNAME, REDIRECTURI, ENABLED) 
--	VALUES ('1', 'key', 'secret', 'My Client', 'https://localhost:9443/oauthclient/redirect.jsp', 1);
	
----- GRANT PRIVILIGES -----
----- UNCOMMENT THE FOLLOWIN IF YOU USE ANOTHER ACCOUNT OTHER THAN ADMINISTRATOR FOR DB ACCESS ----------------

-- Change dbuser to the account you'd like to use to access your database 
-- GRANT ALL ON OAuthDBSchema.OAUTH20CACHE TO USER dbuser;
-- GRANT ALL ON OAuthDBSchema.OAUTH20CLIENTCONFIG TO USER dbuser;

----- END OF GRANT PRIVILIGES -----------------------------------------------------------
	
DISCONNECT CURRENT;