function submitForm(data) {
	var form = createForm(data);
	form.submit();
}

function createForm(data) {
	var form = document.createElement("form");
	form.setAttribute("action", data.authorizationUrl);
	form.setAttribute("method", "POST");
	
	form.appendChild(createInput("nonce", data.nonce));
	form.appendChild(createInput("client_id", data.client_id));
	form.appendChild(createInput("response_type", data.response_type));
	if(data.scope && data.scope.length > 0) {
		form.appendChild(createInput("scope", data.scope.join(" ")));
	}
	if(data.state) {
		form.appendChild(createInput("state", data.state));
	}
	if(data.redirect_uri) {
		form.appendChild(createInput("redirect_uri", data.redirect_uri));
	}
	
	document.body.appendChild(form);
	return form;
}

function createInput(name, value) {
	var input = document.createElement("input");
	input.setAttribute("type", "hidden");
	input.setAttribute("name", name);
	input.setAttribute("value", value);
	return input;
}
